music = new Array()
music[0] = LoadSound("rogue_wobble_try1.mp3", true)
music[1] = LoadSound("rougeboss1.mp3", true)
music[2] = LoadSound("rouge_midfloor1.mp3", true)
music[3] = LoadSound("rouge_dungeon1.mp3", true)

sound = new Array()
sound[0] = LoadSound("jump1.wav");
sound[1] = LoadSound("jump2.wav");
sound[2] = LoadSound("die1.wav");
sound[3] = LoadSound("punch1.wav");
sound[4] = LoadSound("splat1.wav");
sound[5] = LoadSound("thud1.wav");
sound[6] = LoadSound("thud2.wav");

g_current_music = 0;

function PlaySound(number)
{
	sound[number].stop()
	sound[number].setPosition(0)
	sound[number].setPitch(0.9+0.2*Math.random())
	sound[number].play(false);
}

function Print(x)
{
	while (AreKeysLeft())
		GetKey();
	GetSystemFont().drawText(0,0,x);
	FlipScreen();
	GetKey();
}


function StopMusic(number)
{
	music[number].stop();
	music[number].setPosition(0);
}

function PlayMusic(number)
{
	if (g_current_music == number && music[number].isPlaying() == true)
	    return;
	    
	for (var i=0;i<music.length;i++)
	{
		StopMusic(i);
	}
	music[number].setVolume(255)
	music[number].play(true);
	g_current_music = number;
}

function SetCurrentMusicVolume(vol)
{
	music[g_current_music].setVolume(vol)
	if (vol < 1)
	{
		StopMusic(g_current_music);
	}
}
