hp_image = LoadImage("hp1.png")
level_image = LoadImage("level.png")
title_image = LoadImage("title1.png")
controls_image = LoadImage("controls.png")

numbers = Array(10)
for (var i=0;i<10;i++)
{
	numbers[i] = LoadImage(i+".png")
}

gameover_overlay = LoadImage("gameover.png")
game_over_started = -1

g_screen_off = false

function DrawHud()
{
	if (g_level == 1)
	{
		title_image.blit(GetScreenWidth()/2-title_image.width/2+controls_image.width/2, GetScreenHeight()-title_image.height*1.5)
		controls_image.blit(0, GetScreenHeight()-controls_image.height)
	}
	else
	{
		//Draw HP Bar
		hp_image.blit(0,0)
		Rectangle(32*4,1*4, 102*4, 14*4, CreateColor(0,0,0,255))
		Rectangle(33*4,2*4, Math.floor(100*entities[0].hp/entities[0].maxhp)*4, 12*4, CreateColor(255,32,32,255))

		//Draw level:
		y = GetScreenHeight()-level_image.height
		level_image.blit(0,y)
		x = level_image.width

		t_level = g_level
		num_digits = 1
		
		while (t_level>0)
		{
			t_level = t_level/10
			if (Math.floor(t_level) > 0)
			{
				num_digits+=1;
			}
		}
		
		t_level = g_level
		for (var i=num_digits-1;i>=0;i--)
		{
			current_digit = Math.floor(t_level/(Math.pow(10,i)))
			t_level = t_level%(Math.pow(10,i))
			//Debug(num_digits+" "+current_digit+" "+Math.pow(10,i)+" "+i)
			numbers[current_digit].blit(x,y)
			x+=numbers[current_digit].width
		}
	}
	
	if (entities[0].hp<=0)
	{	
		if (game_over_started == -1)
		{
			game_over_started = g_frames
		}
		if (g_frames > 3*60+game_over_started)
		{
			CheckRestart()
		}
		else
		{
			while (AreKeysLeft())
			{
				GetKey()
			}
		}
		
		Rectangle(0,0,GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0,128))
		gameover_overlay.transformBlit(0,0,GetScreenWidth(), 0, GetScreenWidth(), GetScreenHeight(), 0, GetScreenHeight())
	}
	if (g_end_counter > 0)
	{
		BOUNCE = 0.8
		if (g_frame_rate > 10 && g_end_counter % 2 == 0)
		{
			g_frame_rate-=1
		}
		if (g_end_counter > 160)
		{
			g_frame_rate = 80
			Rectangle(0,0,GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0,g_end_counter-180))
			
		}
		
		g_end_counter+=1
		if (g_end_counter-200 > 255)
		{
			Win()
		}
	}
}

function ShowFinalMessage()
{
	str = "It all came down to this..."
	counte = 0
	t_time = GetTime()
	font = LoadFont("font.rfn")
	w = font.getStringWidth(str)*4/2
	r=255
	g=32
	b=32
	font.setColorMask(CreateColor(r,g,b,255))
	for (var c=0;c<250;c++)
	{
		while (GetTime()-t_time<1000/20)
		{
		
		}
		t_time = GetTime()
		DrawGame()
		msg = str.substr(0,Math.floor(c/4))
		
		if (c > 150)
		{
			font.setColorMask(CreateColor(r,g,b,(220-c)*255/70))
		}
		if (c<220)
		{
			font.drawZoomedText(GetScreenWidth()/2-w,GetScreenHeight()/2-2*font.getHeight(), 4, msg)
		}
		FlipScreen()
	}
}

g_end_counter =0 
g_end_enm = -1
function EndGameStarter(k)
{
	ShowFinalMessage()

	g_end_counter = 1
	g_end_enm = k
	
}

function CheckRestart()
{
	if (AreKeysLeft())
	{
		RestartGame()
	}
}


level_texts = new Array()


//TODO: trim this down, no need for exposition on EVERY level.
level_texts[0] = ["It all started a month ago.",  "...The first day of spring."]
level_texts[1] = ["I was in the park.",  "Kids were playing."]
level_texts[2] = ["Then...", "... The rabbits came."]
level_texts[3] = ["The horror...", "... The pain."]
level_texts[4] = ["Since that day,", "I've vowed vengeance..."]
level_texts[5] = ["Vengeance...", "...For my family."]


