EvaluateScript("blood.js");
EvaluateScript("ai.js");
EvaluateScript("keys.js");
EvaluateScript("hud.js");
EvaluateScript("map.js");
EvaluateScript("entities.js");
EvaluateScript("levels.js");
EvaluateScript("audio.js");

function Intro()
{
	image= LoadImage("required.png")
  rate = 1000/60
  last_time = GetTime()
  skip = false
  for (i=0;i<60;i++)
  {
		while (GetTime()-last_time < rate)
		{
			
		}
		last_time = GetTime()
		
		image.transformBlit(0,0, GetScreenWidth(), 0, GetScreenWidth(), GetScreenHeight(), 0, GetScreenHeight())
		Rectangle(0,0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0, 255-255*i/60))
		FlipScreen()
		if (AreKeysLeft())
		{
			skip = true
			i=60-i;
			break
		}
  }
  if (skip == false)
  {
		i=0;
  }
  for (;i<60;i++)
  {
		while (GetTime()-last_time < rate)
		{
			
		}
		last_time = GetTime()
		
		image.transformBlit(0,0, GetScreenWidth(), 0, GetScreenWidth(), GetScreenHeight(), 0, GetScreenHeight())
		//Rectangle(0,0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0, 255*i/60))
		if (AreKeysLeft())
		{
			skip = true
			break
		}
		FlipScreen()
  }
  if (skip == false)
  {
		i=0;
  }
  for (;i<60;i++)
  {
		while (GetTime()-last_time < rate)
		{
			
		}
		last_time = GetTime()
		
		image.transformBlit(0,0, GetScreenWidth(), 0, GetScreenWidth(), GetScreenHeight(), 0, GetScreenHeight())
		Rectangle(0,0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0, 255*i/60))
		FlipScreen()
  }
	while (AreKeysLeft())
	{
		GetKey()
	}
}

function game()
{
	Intro()
	Menu()
	StartGame()
}

function Menu()
{

}

function StartGame()
{
   SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "StartScript();")
   MapEngine("base1.rmp", 60)
   
}

function StartScript()
{
  SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "")
  SetLayerRenderer(2, "FloorRenderer();")
	PrepEntitiesFirstTime()
	StartLevel(1);
	MainLoop()

}

function PrepLayers()
{
	for (i=0;i<GetNumLayers();i++)
	{
		SetLayerScaleFactorX(i, 4)
		SetLayerScaleFactorY(i, 4)
	}
}

function FloorRenderer()
{
	DrawBloodOverlay()
}

g_level = 0
function StartLevel(num)
{
	ClearEntities()
	
	g_level = num
	MakeNewMap()
	GenerateTilesFromObstructions();
	PrepEntities();
	PrepLayers();
	UpdateEntities();
	ResetBlood();
	if (num < 2)
		;
	else if (num == 5)
	{
		PlayMusic(1)
	}
	else if (num <5)
	{
		PlayMusic(0)
	}
	else if (num <8)
	{
		PlayMusic(2)
	}
	else 
	{
		PlayMusic(3)
	}
	    
	
	FadeLevel("in");

}


g_frames = 0
g_frame_rate = 80
function MainLoop()
{
	g_frame_rate = 80
	lastTime = GetTime()-1000
	while (true)
	{
	  while (GetTime()-lastTime < 1000/g_frame_rate)
	  {
	  }
	  lastTime = GetTime()
		
		UpdateEntities()
		UpdatePlayer()
		DrawGame()
		g_frames += 1
		GetSystemFont().drawText(0,30, debug_mess)
		GetSystemFont().drawText(0,debug_mess2y, debug_mess2)
		FlipScreen();
	}
}

function DrawGame()
{
	CheckBloodOverlayRecalc();
	if (g_screen_off)
	{
	  seq = [-4,0,4,0]
		cx = GetCameraX() + seq[Math.floor(g_frames/2)%4];
		cy = GetCameraY() + seq[Math.floor(g_frames/3)%4];
		
		SetCameraX(cx);
		SetCameraY(cy);
	}
	RenderMap();
	DrawHud()
}

function Debug(stringy)
{
	return
	GetSystemFont().drawText(0,0,stringy)
	FlipScreen()
	GetKey()
}

debug_mess = ""
function Debug2(stringy)
{
	return
	debug_mess = stringy
}

debug_mess2 = ""
debug_mess2y = 0
function Debug3(stringy,y)
{
	return
	debug_mess2 = stringy
	debug_mess2y = y
}


function sign(x)
{
	if (x>0)
	{
		return 1
	}
	if (x<0)
	{
		return -1
	}
	return 0
	return 0
}