
g_exit = [0,0]
g_start = [0,0]

exit_width = 7
exit_height = 7

function GetFullTile(x,y)
{
	if (x < 0 || y < 0 || x > 1600/TILE || y > 900/TILE)
	{
		return 7
	}
	return GetTile(x,y,0)
}

function GetObsTile(x,y, ignore_exit)
{
	var t = GetFullTile(x,y)
	if (t == 7 || (ignore_exit==true && t == 64))
	{
		return 1
	}
	return 0
}

floor_tiles = [45,46,50,51]

defs = Array()
for (i=0;i<31;i++)
{
	defs[i] = new Object()
	defs[i].d = new Array(3)
	for (ii=0;ii<4;ii++)
	{
		defs[i].d[ii] = [-1,-1,-1]
	}
	defs[i].s = [-1,-1,-1,-1,-1,-1]
}

i=0
//black
defs[i].d[0] = [ 1, 1, 1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1, 1]
defs[i].d[3] = [ 1, 1, 1]
defs[i].s = [-1,-1,-1, 4, -1,-1] 

i++;
//floors
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [ 1, 0,-1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, 52, -1,-1,-1] 

i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 0, 1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, 54, -1,-1,-1] 

i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [ 0, 0, 0]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,-1,-1] 

//floor overlays from above

i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 0,-1]
defs[i].d[2] = [ 1, 1, 1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,-1,12] 

i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [ 0, 0, 0]
defs[i].d[2] = [ 1, 1, 0]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,-1,13] 

i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [ 0, 0,-1]
defs[i].d[2] = [ 0, 1, 1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,-1,11] 



//main brick wall
i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 1,-1]
defs[i].d[2] = [-1, 0,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1,22, -1, -1,-1,-1] 

//top corners and top
i++;
defs[i].d[0] = [-1, 0, 0]
defs[i].d[1] = [-1, 1, 0]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,37,-1] 


i++;
defs[i].d[0] = [ 0, 0,-1]
defs[i].d[1] = [ 0, 1,-1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,36,-1] 

i++;
defs[i].d[0] = [-1, 0,-1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,32,-1] 


//left and right walls
i++
defs[i].d[0] = [-1, 1,-1]
defs[i].d[1] = [-1, 1, 0]
defs[i].d[2] = [-1, 1,-1]
defs[i].d[3] = [-1, 1,-1]
defs[i].s = [-1, 1, -1, -1,26,-1] 

i++
defs[i].d[0] = [-1, 1,-1]
defs[i].d[1] = [ 0, 1,-1]
defs[i].d[2] = [-1, 1,-1]
defs[i].d[3] = [-1, 1,-1]
defs[i].s = [-1, 1, -1, -1,28,-1] 


//bottom left/right inner corners
i++
defs[i].d[0] = [-1, 1, 0]
defs[i].d[1] = [-1, 1, 1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,31,-1] 

i++
defs[i].d[0] = [ 0, 1,-1]
defs[i].d[1] = [ 1, 1,-1]
defs[i].d[2] = [-1,-1,-1]
defs[i].d[3] = [-1,-1,-1]
defs[i].s = [-1, 1, -1, -1,33,-1] 


//top left/right inner corners
i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 1, 1]
defs[i].d[2] = [-1, 1, 1]
defs[i].d[3] = [-1, 1, 0]
defs[i].s = [-1, 1, -1, -1,16,-1] 

i++
defs[i].d[0] = [-1, 1,-1]
defs[i].d[1] = [ 1, 1,-1]
defs[i].d[2] = [ 1, 1,-1]
defs[i].d[3] = [ 0, 1,-1]
defs[i].s = [-1, 1, -1, -1,18,-1] 


//minor left/right top walls
i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 1, 1]
defs[i].d[2] = [-1, 1, 0]
defs[i].d[3] = [-1, 1,-1]
defs[i].s = [-1, 1, -1, -1,21,-1] 

i++
defs[i].d[0] = [-1, 1,-1]
defs[i].d[1] = [ 1, 1,-1]
defs[i].d[2] = [ 0, 1,-1]
defs[i].d[3] = [-1, 1,-1]
defs[i].s = [-1, 1, -1, -1,23,-1] 

//bottom left/right outer corners
i++;
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 1,-1]
defs[i].d[2] = [-1, 1, 0]
defs[i].d[3] = [-1, 0, 0]
defs[i].s = [-1, 1, -1, -1,42,-1] 

i++
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [-1, 1,-1]
defs[i].d[2] = [ 0, 1,-1]
defs[i].d[3] = [ 0, 0,-1]
defs[i].s = [-1, 1, -1, -1,41,-1] 

//main brick wall one above
i++
defs[i].d[0] = [-1,-1,-1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [-1, 1, 1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, 17,-1,-1] 

//weird edge case of a horizontal 2 thick wall
i++
defs[i].d[0] = [-1, 0,-1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1, 1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, -1,29,-1] 


i++
defs[i].d[0] = [-1, 0,-1]
defs[i].d[1] = [ 0, 1, 1]
defs[i].d[2] = [-1, 1, 1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, -1,24,-1] 


i++
defs[i].d[0] = [-1, 0,-1]
defs[i].d[1] = [ 1, 1, 0]
defs[i].d[2] = [ 1, 1,-1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, -1,19,-1] 

//Stanger 2 wal edge case

i++
defs[i].d[0] = [ 0, 1, 1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1,-1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, -1,30,-1] 

i++
defs[i].d[0] = [ 1, 1, 0]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [-1, 1, 1]
defs[i].d[3] = [-1, 0,-1]
defs[i].s = [-1, 1, -1, -1,34,-1] 

i++
defs[i].d[0] = [-1, 0, 0]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [-1, 1, 1]
defs[i].d[3] = [-1, 1, 0]
defs[i].s = [-1, 1, -1, -1,40,-1] 

i++
defs[i].d[0] = [ 0, 0,-1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1,-1]
defs[i].d[3] = [ 0, 1,-1]
defs[i].s = [-1, 1, -1, -1,35,-1] 

//very strange minor double corner
i++
defs[i].d[0] = [ 0, 1, 1]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1, 1]
defs[i].d[3] = [ 1, 1, 0]
defs[i].s = [-1, 1, -1, -1,48,-1] 

i++
defs[i].d[0] = [ 1, 1, 0]
defs[i].d[1] = [ 1, 1, 1]
defs[i].d[2] = [ 1, 1, 1]
defs[i].d[3] = [ 0, 1, 1]
defs[i].s = [-1, 1, -1, -1,47,-1] 




i++
max_defs = i;


function GenerateTilesFromObstructions()
{
	
	
	g_quit = [-1,-1]
	max_x = Math.floor(1600/TILE)
	max_y = Math.floor(900/TILE)
	//Clear out map first

	for (var layer = 1; layer < 6;layer++)
	{
		for (var i=0;i<max_x;i++)
		{
			for (var j=0;j<max_y;j++)
			{
				SetTile(i,j,layer, 0)
			}
		}
	}

	
	for (var i=0;i<max_x;i++)
	{
		for (var j=0;j<max_y;j++)
		{
			for (var d=0;d<max_defs;d++)
			{
				def_match = true
				def = defs[d].d
				for (h=0;h<4;h++)
				{
					for (k=0;k<3;k++)
					{
						t = GetObsTile(i-1+k, j-1+h)
						if (def[h][k] == 0 && t!= 0)
						{
							def_match=false
							h=4
							break
						}
						if (def[h][k] == 1 && t!= 1)
						{
							def_match=false;
							h=4;
							break
						}
						
					}
				}
				if (def_match == true)
				{
					for (var l=0;l<6;l++)
					{
						if (defs[d].s[l] != -1)
						{
							SetTile(i,j,l, defs[d].s[l])
						}
					}
				}
			}


			/*
			if (GetObsTile(i,j) != 7)
			{
				SetTile(i,j,1, floor_tiles[(i+2*(j%2))%4])
				if (GetObsTile(i-1,j) == 7)
				{
					SetTile(i,j,2, 52)
				}
				else if (GetObsTile(i+1,j) == 7)
				{
					SetTile(i,j,2, 54)
				}
			}
			else
			{
				if (GetObsTile(i,j+1) != 7)
				{
					SetTile(i,j, 1, 22)
				}
				else if (GetObsTile(i+1,j) != 7)
				{
					if (GetObsTile(i-1, j) != 7)
					{
						SetTile(i,j, 3, 37)
					}
					else
					{
						SetTile(i,j, 3, 26)
					}
				}
				else if (GetObsTile(i-1,j) != 7)
				{
					SetTile(i,j, 3, 28)
				}
			}
			*/
		
		}
	
	}

	for (var i=0;i<max_x;i++)
	{
		for (var j=0;j<max_y;j++)
		{
			if (GetTile(i,j,1) == 1)
			{
				SetTile(i,j,1, floor_tiles[(i+2*(j%2))%4])
			}
			
			tile = GetTile(i,j,0)
			if (tile == 60)
			{
				AddEnemy(i,j,0)			
			}

			if (tile == 65)
			{
				AddEnemy(i,j,2)			
			}
			if (tile == 66)
			{
				AddEnemy(i,j,3)			
			}


			if (tile == 62)
			{
			  //exit
				SetTile(i,j,3,20)
				g_exit = [i,j]
			}
			if (tile == 61 && g_level > 1)
			{
				//entrance
				SetTile(i,j,3,25)
				g_start = [i,j]
			}		
			if (tile ==63)
			{
				SetTile(i,j, 4, 39)
			}
			
			if (tile == 64)
			{
				SetTile(i,j, 4, 15)
				SetTile(i,j+1, 1, 55)
				g_start = [i,j+1]
				g_quit = [i,j]
			}
			
		}
	}
}

prime = 1000000007
g_seed = Math.floor(Math.random()*prime)
function Random()
{
	g_seed = (g_seed * (4 * 123456789 + 1) + 123456789) % prime
	
	return (1.0*g_seed)/1000000007
}


g_boss1 = 5;//8
g_boss2 = 11;//16

rooms = Array()

g_map_changes = [5,8,20]

function MakeNewMap()
{
	if (g_level < g_map_changes[0])
	{
		num=1
	}
	else if (g_level < g_map_changes[1])
	{
		num=2
	}
	else if (g_level < g_map_changes[2])
	{
		num=3
	}
	ChangeMap("base"+num+".rmp")
  SetLayerRenderer(2, "FloorRenderer();")
	abs_max_width = 1600/16
	abs_max_height = 900/16
	
	scale_factor = Math.min(0.15+0.2*(g_level-1), 1)
	
	max_width = Math.floor(abs_max_width*scale_factor)
	max_height = Math.floor(abs_max_height*scale_factor)
	
	for (var i=0;i<abs_max_width;i++)
	{
		for (var j=0;j<abs_max_height;j++)
		{
			SetTile(i,j, 0, 7)
		}
	}
	
	
	if (g_level == g_boss1)
	{
		MakeBossLevel()
		return
	}
	else if (g_level == g_boss2)
	{
		MakeFinalLevel()
		return
	}
	

	
	rooms = new Array()
	num_rooms = Math.floor((40*Random()+10)*scale_factor)
	if (num_rooms < 2)
	{
		num_rooms = 2;
	}
	for (k=0;k<num_rooms;k++)
	{
		size_w = Math.floor(Random()*5*(Math.sqrt(scale_factor)))+3
		size_h = Math.floor(Random()*5*(Math.sqrt(scale_factor)))+3
	
		x = Math.floor(Random()*(max_width-4))+2
		y = Math.floor(Random()*(max_height-4))+2
		if (y < 2)
		{
			y=2;
		}
		
		w = Math.floor(size_w*Random()+3)
		h = Math.floor(size_h*Random()+3)
		
		if (x+w > max_width-2)
		{
			w = max_width-2-x
		}
		if (y+h > max_height-2)
		{
			h = max_height-2-y
		}
		rooms[k] = new Object()
		rooms[k].x = x
		rooms[k].y = y
		rooms[k].w = w
		rooms[k].h = h
		rooms[k].connect = 0
		CreateRoom(x,y,w,h)
		
	}
	//now do a spanning tree algorithm to join the rooms together.
	for (var i=0;i<num_rooms;i++)
	{
		dist = 10000
		best = -1
		for (var j=i+1; j<num_rooms;j++)
		{
			d = Math.abs(rooms[i].x-rooms[j].x)+Math.abs(rooms[i].y-rooms[j].y)
			if (d<dist)
			{
				dist = d
				best = j
			}
		}
		if (best != -1)
		{
			JoinRooms(i,best)
			rooms[i].connect+=1;
			rooms[best].connect+=1;
		}
	}
	
	for (var l=0;l<num_rooms;l++)
	{
		//compute rooms that have overlap, or close to overlap:
		for (var k=0;k<num_rooms;k++)
		{
			if (l==k)
			{
				continue
			}
			fail = false
			checks = [[rooms[k].x-1, rooms[k].y-1], [rooms[k].x-1+rooms[k].w+1, rooms[k].y-1],
								[rooms[k].x-1, rooms[k].y+1+rooms[k].h], [rooms[k].x+1+rooms[k].w, rooms[k].y+1+rooms[k].h]]
								
			for (var m=0;m<4;m++)
			{
				if (rooms[l].x<=checks[m][0] && checks[m][0] < rooms[l].x+rooms[l].w &&
						rooms[l].y<=checks[m][1] && checks[m][1] < rooms[l].y+rooms[l].h)
				{
					fail = true
				}
			}
			if (fail == true)
			{
				rooms[l].connect+=1;
				rooms[k].connect+=1;
			}
		}
	
	}
	
	//create start and end points
	
	dist = 0
	best = [0,10]
	
	tnum = Math.floor(num_rooms/6)
	if (tnum < 2)
	{
		tnum = 2
	}
	if (tnum*2 > rooms.length)
	{
		tnum = 1
	}
	
	for (var i=0;i<tnum;i++)
	{
		for (var j=tnum; j<tnum*2;j++)
		{
			d = Math.abs(rooms[i].x-rooms[j].x)+Math.abs(rooms[i].y-rooms[j].y)
			if (d > dist)
			{
				dist = d
				best = [i,j]
			}
		}
	}
	
	exit_i = best[0]
	exit_j = best[1]
	//Set entrance:

	SetTile(rooms[exit_i].x+1, rooms[exit_i].y+1, 0, 61)
	//Set exit
	SetTile(rooms[exit_j].x+1, rooms[exit_j].y+1, 0, 62)
	
	chests = 0;//1+Math.floor(num_rooms/10)
	
	if (g_level < 3)
	{
		chests = 0
	}
	
	for (var i=0;i<num_rooms;i++)
	{
		if (rooms[i].connect == 1 && i!=exit_i && i!=exit_j && chests > 0)
		{
			chests-=1;
			x = rooms[i].x+Math.floor(rooms[i].w*Random())
			y = rooms[i].y+Math.floor(rooms[i].h*Random())
				
			if (GetTile(x,y,0) == 6)
			{
				SetTile(x,y,0, 63)
			}
		}
		
		if (g_level > 1)
		{
		  r = Random()
			num_rabbits = Math.floor(Math.pow(5+g_level, 0.333)*(r*r))
			
			for (var r=0;r<num_rabbits;r++)
			{
				x = rooms[i].x+Math.floor(rooms[i].w*Random())
				y = rooms[i].y+Math.floor(rooms[i].h*Random())
					
				if (GetTile(x,y,0) == 6)
				{
					SetTile(x,y,0, 60)
				}
			
			}
			
		}
	}

	
	
	for (var l=0;l<3;l++)
	{
		for (var i=0;i<max_width;i++)
		{
			for (var j=0;j<max_height;j++)
			{
				if (GetObsTile(i,j))
				{
					if (GetObsTile(i-1,j)==0 && GetObsTile(i+1, j) == 0  ||
							GetObsTile(i,j-1)==0 && GetObsTile(i, j+1) == 0
						 )
					{
						SetTile(i,j,0,6)				
					}
					
					if (GetObsTile(i+1,j) == 0 && GetObsTile(i,j+1) == 0 && GetObsTile(i+1,j+1) == 1)
					{
						SetTile(i+1,j+1,0,6)
					}
					if (GetObsTile(i-1,j) == 0 && GetObsTile(i,j+1) == 0 && GetObsTile(i-1,j+1) == 1)
					{
						SetTile(i-1,j+1,0,6)
					}

					if (GetObsTile(i,j) == 1 && GetObsTile(i-1,j) == 0 && GetObsTile(i+1,j+1) == 0 && GetObsTile(i,j+1) == 1 && GetObsTile(i-1,j+1) == 1)
					{
						SetTile(i,j,0,6)
					}
					if (GetObsTile(i,j) == 1 && GetObsTile(i+1,j) == 0 && GetObsTile(i-1,j+1) == 0 && GetObsTile(i,j+1) == 1 && GetObsTile(i+1,j+1) == 1)
					{
						SetTile(i,j,0,6)
					}


					if (GetObsTile(i,j) == 1 && GetObsTile(i,j+1) == 0 && GetObsTile(i-1,j) == 1 && GetObsTile(i+1,j) == 0 && GetObsTile(i,j-1) == 0)
					{
						if (GetObsTile(i+1,j+1) == 0 && GetObsTile(i-1,j-1) == 0)
						{
							SetTile(i,j,0,6)
						}
						if (GetObsTile(i-1,j+1) == 0 && GetObsTile(i+1,j-1) == 0)
						{
							SetTile(i,j,0,6)
						}
					}

				}
			}
		}
	}



	if (g_level == 1)
	{
		//Add quit thingy
		exit = false
		dx=0
		
		//0,-1,1,-2,2,-3,3,-4,4
		//-1,2,-3,4,-5,6
		while (exit==false && dx < 8)
		{
			for (var y = rooms[exit_i].y; y> 0;y--)
			{
				if (GetObsTile(rooms[exit_i].x+dx, y) == 1 && GetObsTile(rooms[exit_i].x+1+dx, y) == 1 && GetObsTile(rooms[exit_i].x-1+dx, y) == 1 && GetObsTile(rooms[exit_i].x+dx, y+1) == 0)
				{
					SetTile(rooms[exit_i].x+dx, y,0, 64);
					exit=true;
					break
				}
			}
			dx=-dx;
			if (dx<=0)
				dx-=1;
		}
	}

}

function CreateRoom(x,y,w,h)
{
	for (var i=x; i<x+w;i++)
	{
		for (var j=y; j<y+h;j++)
		{
			SetTile(i,j,0,6)
		}
	}
}

function JoinRooms(i,j)
{

	x1=rooms[i].x+Math.floor((rooms[i].w-2)*Random())
	y1=rooms[i].y+Math.floor((rooms[i].h-2)*Random())
	
	x2=rooms[j].x+Math.floor((rooms[j].w-2)*Random())
	y2=rooms[j].y+Math.floor((rooms[j].h-2)*Random())
	
	if (Random() <0.5)
	{
		//x1,y1->x2,y1
		if (x1<x2)
		{
			CreateRoom(x1,y1, x2-x1+2, 2)
		}
		else
		{
			CreateRoom(x2,y1, x1-x2+2, 2)
		}
		//x2,y1->x2,y2

		if (y1<y2)
		{
			CreateRoom(x2,y1, 2, y2-y1+2)
		}
		else
		{
			CreateRoom(x2,y2, 2, y1-y2+2)
		}	
	}
	else
	{
		//x1,y1->x1,y2
		if (y1<y2)
		{
			CreateRoom(x1,y1, 2, y2-y1+2)
		}
		else
		{
			CreateRoom(x1,y2, 2, y1-y2+2)
		}

		//x1,y2->x2,y2
		if (x1<x2)
		{
			CreateRoom(x1,y2, x2-x1+2, 2)
		}
		else
		{
			CreateRoom(x2,y2, x1-x2+2, 2)
		}
	
	}
}



function MakeBossLevel()
{
  x=40
	c = 45
  hor = Math.floor(2*Random())


	
	if (hor == 0)
	{
		CreateRoom(40,26, 13,11)
		CreateRoom(20,c-15, 50, 3)
		start_end = [[21,c+1-15], [68,c+1-15]]
	}
	else
	{
		CreateRoom(41,25, 11,13)
		CreateRoom(c, 5, 3, 50)
		start_end = [[c+1,6], [c+1,53]]
	}

  r = Math.floor(Random()*2)	
	SetTile(start_end[r][0], start_end[r][1], 0, 61)
	SetTile(start_end[(r+1)%2][0], start_end[(r+1)%2][1], 0, 62)

	SetTile(c+1,c-14, 0, 65)
}

function MakeFinalLevel()
{
	CreateRoom(20, 20, 7,5)
	CreateRoom(22, 25, 3, 10)

	SetTile(23, 33, 0, 61)
	SetTile(90, 0, 0, 62)

	SetTile(23, 23, 0, 66)
}

